<?php

$documentRoot = $_SERVER["DOCUMENT_ROOT"];
require_once "$documentRoot/libs/REST_Resource.class.php";
require_once "$documentRoot/libs/paloSantoDB.class.php";
require_once "$documentRoot/libs/paloSantoJSON.class.php";

/*
 * Para esta implementación de REST, se tienen los siguientes URI
 * 
 * 
 *  /RegistrationInfo  application/json
 *      GET     Get registration data
 * 
 */

class RegistrationInfo
{

    function URIObject()
    {   
    	$uriObject = NULL;
        $uriObject = new RegistrationDataResource();
        return $uriObject;
    }
}

class GetRegData 
{
    
    function getDaysRemaining($license) {

        $db = new paloDB("sqlite3:////var/www/db/OrkestalConfig.db");
        $query = "SELECT 1 FROM OrkestalConfig WHERE licnumber='".$license."'";
        $result = $db->getFirstRowQuery($query,TRUE);
        if(count($result) != 1) {
            return "not in db";            
        } 

        $lic = explode("-",$license);
        $expire = strtotime(substr($lic[6],2)."-".substr($lic[6],0,2)."-20".substr($lic[5],2)); //TODO: This will be wrong when we reach the year 2100
        $now = strtotime(date("d-m-Y"));
        $diff = $expire - $now;
        
        if($diff <= 0){
            $days = 0;
        }
        else{
            $days = $diff/86400;                    
        }
        return $days;                
    }

    function listregData()
    {
        
        $db = new paloDB("sqlite3:////var/www/db/OrkestalConfig.db");
     	$query = "SELECT licnumber,company,lockconfiguration,unlockpassword FROM OrkestalConfig WHERE id=1";
    	$result = $db->getFirstRowQuery($query,TRUE);
    	if($result === FALSE)
    		return NULL;
    	$res = array();
    	if(count($result) > 0)
    	        $res = array("license_number"     => $result["licnumber"],
    			     "company"   	  => $result["company"],
    			     "lock_configuration" => $result["lockconfiguration"],
    			     "unlock_password"    => $result["unlockpassword"]
    		);
    	else
    		return NULL;
        return $res;
            
    }
}

class RegistrationDataResource extends REST_Resource
{
    
    function HTTP_GET()
    {
        
        $action=$_GET['action'];
        $licnumber=$_GET['licnumber'];
        
        if ($action=='days') {
            
            
            $regData = new GetRegData();
            $json = new Services_JSON();
            $result = $regData->getDaysRemaining($licnumber);            
            $data = Array("daysremaining" => $result);
            return $json->encode($data);            
        }
        
    
        $regData = new GetRegData();
	    $json = new Services_JSON();
        $result = $regData->listregData();
	    if(!isset($result)){  
		  $res = array("error" => "A database error ocurred");
		  return $json->encode($res);
	    }
        $res = Array("license_number" => $result['license_number'],
                     "lock_configuration" => $result['lock_configuration'],
                     "unlock_password" => $result['unlock_password'],
                     "company" => $result['company']
                    ); 
        
        return $json->encode($res);
    
    }
    
}

?>
